// ATLBandit.h : Declaration of the CATLBandit

#ifndef __ATLBANDIT_H_
#define __ATLBANDIT_H_

#include "resource.h"       // main symbols
#include <atlctl.h>
#include "OneArmedBanditATLCP.h"


/////////////////////////////////////////////////////////////////////////////
// CATLBandit
class ATL_NO_VTABLE CATLBandit : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CStockPropImpl<CATLBandit, IATLBandit, &IID_IATLBandit, &LIBID_ONEARMEDBANDITATLLib>,
	public CComControl<CATLBandit>,
	public IPersistStreamInitImpl<CATLBandit>,
	public IOleControlImpl<CATLBandit>,
	public IOleObjectImpl<CATLBandit>,
	public IOleInPlaceActiveObjectImpl<CATLBandit>,
	public IViewObjectExImpl<CATLBandit>,
	public IOleInPlaceObjectWindowlessImpl<CATLBandit>,
	public IConnectionPointContainerImpl<CATLBandit>,
	public IPersistStorageImpl<CATLBandit>,
	public ISpecifyPropertyPagesImpl<CATLBandit>,
	public IQuickActivateImpl<CATLBandit>,
	public IDataObjectImpl<CATLBandit>,
	public IProvideClassInfo2Impl<&CLSID_ATLBandit, &DIID__IATLBanditEvents, &LIBID_ONEARMEDBANDITATLLib>,
	public IPropertyNotifySinkCP<CATLBandit>,
	public CComCoClass<CATLBandit, &CLSID_ATLBandit>,
	public CProxy_IATLBanditEvents< CATLBandit >
{
public:
	CATLBandit()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ATLBANDIT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CATLBandit)
	COM_INTERFACE_ENTRY(IATLBandit)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_PROP_MAP(CATLBandit)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("BackColor", DISPID_BACKCOLOR, CLSID_StockColorPage)
	PROP_ENTRY("ForeColor", DISPID_FORECOLOR, CLSID_StockColorPage)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(CATLBandit)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
	CONNECTION_POINT_ENTRY(DIID__IATLBanditEvents)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CATLBandit)
	CHAIN_MSG_MAP(CComControl<CATLBandit>)
	DEFAULT_REFLECTION_HANDLER()
	MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IATLBandit
public:
	STDMETHOD(get_NumberOfSymbols)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_NumberOfSymbols)(/*[in]*/ short newVal);

	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		RECT& rc = *(RECT*)di.prcBounds;
		Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);

		SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
		LPCTSTR pszText = _T("ATL 3.0 : ATLBandit");
		TextOut(di.hdcDraw, 
			(rc.left + rc.right) / 2, 
			(rc.top + rc.bottom) / 2, 
			pszText, 
			lstrlen(pszText));

		return S_OK;
	}
	OLE_COLOR m_clrBackColor;
	OLE_COLOR m_clrForeColor;
protected:
	short m_numberOfSymbols;
	LRESULT OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		Fire_Click();
		return 0;
	}
};

#endif //__ATLBANDIT_H_
